commit 1b88acb34288b0858d0f26c1ab2ebc752d046595
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Dec 1 18:17:46 2025 +0000

    Fix nonstandard DNS server port number use from perl.  Bug 3177
    
    Broken-by: 040f2adb9003

diff --git a/src/src/miscmods/perl.c b/src/src/miscmods/perl.c
index 1b111e711..cee920c77 100644
--- a/src/src/miscmods/perl.c
+++ b/src/src/miscmods/perl.c
@@ -200,19 +200,26 @@ perl_parse(interp_perl, xs_init, argc, argv, 0);
 perl_run(interp_perl);
 
 /*********************************************************************/
+errstr = exim_perl_add_codeblock(US
+
 /* These lines by PH added to make "warn" output go to the Exim log; I
 hope this doesn't break anything. */
 
-errstr = exim_perl_add_codeblock(US
   "$SIG{__WARN__} = sub { my($s) = $_[0];"
   "$s =~ s/\\n$//;"
   "Exim::log_write($s) };"
 
-/* These lines added by JGH to route DNS queries via Exim's facilities */
+/* These lines added by JGH to route DNS queries via Exim's facilities.
+If a port was specified, we punt.
+*/
 
   "package Net::DNS::Resolver;"
   "sub send {"
-        "my ( $self, $dom, $rrtype_str ) = @_;"
+	"my $self = shift;"
+
+	"return $self->SUPER::send(@_) if ($self->{'port'} != 53);"
+
+        "my ( $dom, $rrtype_str ) = @_;"
 	"my $rr = {"
 	"\"A\"     => 1,"
 	"\"NS\"    => 2,"

